<!doctype html>
<html class="no-js" lang="">
    @@include('./template/_head.html')
    <body>
    	
    	@@include('./template/_header.html')
    	<div class="pageWrap">
    		
            <div id="pdcnt">
                <p class="pdcnt_ctg">TOP</p>
        		<div class="pdcnt_sliderWrap" v-for="(colorSet, index) in allData" v-bind:class="{'active': (index === currentIdx)}">
                    <div class="pdcnt_slide">
                        <div v-for="(imgPath, index) in colorSet.imgs">
                            <img :src=[imgPath]>
                        </div>
                    </div>
                </div>
            
                <p class="pdcnt_subtitle">THE SIDE SKIRT</p>
                <p class="pdcnt_title">俐落斜片側綁帶雪紡裙</p>
                <div class="pdcnt_price sale">
                    <p class="pdcnt_price_o_dec">NT 1,580</p>
                    <p>
                        特價NT
                        <span>980</span>
                    </p>
                </div>

                <div class="pdcnt_color">
                    <p>COLOR <span class="js-colorname">{{currentColor.name}}</span></p>
                    <ul class="js-color clearfix">
                        <li v-for="(colorSet, index) in allData" :class="{'active': (index === currentIdx)}">
                            <a href="#" @click="changeColor" :data-idx=[index]>
                                <img :src=[colorSet.color.img]>
                            </a>
                        </li>
                    </ul>
                </div>


                <div class="pdcnt_size">
                    
                    <ul v-for="(colorSet, index) in allData" v-show="index === currentIdx" class="clearfix">
                        <li v-for="(size, index) in colorSet.size" :class="{'active': (index === currentSizeIdx)}">
                            <a href="#" :class="{'disabled': (size.qty === 0)}" :data-maxqty=[size.qty] :data-idx=[index] @click="changeSize">{{size.name}}</a>
                        </li>
                    </ul>

                </div>

                <div class="pdcnt_number clearfix">
                    <input type="text" name="" class="js-number" :value="currentNumber">

                    <div class="pdcnt_social">
                        <a href="#" class="ess-icon line"></a>
                        <a href="#" class="ess-icon ig"></a>
                        <a href="#" class="ess-icon fb"></a>
                    </div>
                </div>

                <div class="pdcnt_btn">
                    <a href="#" class="btn addToCart" v-show="!nostock">
                        <span class="ess-icon"></span>加入購物車
                    </a>
                    <a href="#" class="btn addToCart" v-show="nostock">
                        <span class="ess-icon"></span>加入購物車
                    </a>
                    <a href="#" class="btn_frame checkout">
                        <span class="ess-icon"></span>直接結帳
                    </a>
                </div>

                <!-- tab -->
                <div class="c-tabs" id="pdcnt_tab">
                    <div class="c-tabs-nav clearfix">
                        <a href="#" class="c-tabs-nav__link is-active">商品描述</a>
                        <a href="#" class="c-tabs-nav__link">洗滌說明</a>
                        <a href="#" class="c-tabs-nav__link">碼數指南</a>
                    </div>

                    <!-- tab content -->
                    <!-- 商品描述 -->
                    <div class="c-tab is-active">
                        <div class="c-tab__content">
                            <p>*實品顏色依單品照為主</p>
                            <p>V領設計/面料柔軟舒適</p>
                            <p>棉60%  纖維40%</p>
                            <p>FABRIC: TAIWAN    MADE IN TAIWAN</p>
                        </div>
                    </div>

                    <!-- 洗滌說明 -->
                    <div class="c-tab is-active">
                        <div class="c-tab__content">
                            <ol>
                                <li>深淺色請分開洗滌，以避免造成互相移染。</li>
                                <li>請放入大小適中之細網洗衣袋中弱速水洗，以保持商品型態。</li>
                                <li>洗滌時，水溫請低於30度C；請使用中性洗劑；請勿長時間浸泡。</li>
                                <li>請勿使用漂白劑、螢光增白劑及衣物柔軟劑，以免破壞布料。</li>
                                <li>不可濕放，以免衣物染色；請弱速輕脫水，不可烘乾，以免衣物縮水。</li>
                                <li>請採用陰乾方式晾乾，不可擰扭；如需整燙，請以低溫墊布熨燙。（針織商品請平放晾乾）</li>
                                <li>穿著時，請留意避免與配件包包等它物接觸摩擦而造成移染情況發生。</li>
                            </ol>
                        </div>
                    </div>

                    <!-- 碼數指南 -->
                    <div class="c-tab is-active">
                        <div class="c-tab__content">
                            <p>SIZE GUIDE</p>   
                            <br>
                            <p style="font-size: 12px">SIZE CHART 平鋪尺寸表（CM）</p>
                            <img src="images/assets/sizeguide.jpg">
                        </div>
                    </div>

                </div><!-- end tab -->


                <!-- 凡人穿搭 -->
                <div class="pdcnt_relatedlist clearfix">
                    <img src="images/titles/peopleLook.jpg" class="sectionTitle">
                    <div class="secSlide">
                        <ul>
                            <li>
                                <a href="#">
                                    <img src="images/assets/lookbookThumb.jpg">
                                </a>
                            </li>
                            <li>
                                <a href="#">
                                    <img src="images/assets/lookbookThumb2.jpg">
                                </a>
                            </li>
                            <li>
                                <a href="#">
                                    <img src="images/assets/lookbookThumb3.jpg">
                                </a>
                            </li>
                            <li>
                                <a href="#">
                                    <img src="images/assets/lookbookThumb.jpg">
                                </a>
                            </li>
                            <li>
                                <a href="#">
                                    <img src="images/assets/lookbookThumb2.jpg">
                                </a>
                            </li>
                            <li>
                                <a href="#">
                                    <img src="images/assets/lookbookThumb3.jpg">
                                </a>
                            </li>
                        </ul>
                        <a href="#" class="ess-icon banner-prev"></a>
                        <a href="#" class="ess-icon banner-next"></a>
                    </div>
                    <a href="snaplist.html" class="btn">more</a>
                </div>


                <!-- 你可能會喜歡 -->
                <div class="pdcnt_relatedlist clearfix">
                    <img src="images/titles/likeit.jpg" class="sectionTitle">
                    <div class="secSlide">
                        <ul>
                            <li>
                                <a href="#">
                                    <img src="images/assets/lookbookThumb.jpg">
                                </a>
                            </li>
                            <li>
                                <a href="#">
                                    <img src="images/assets/lookbookThumb2.jpg">
                                </a>
                            </li>
                            <li>
                                <a href="#">
                                    <img src="images/assets/lookbookThumb3.jpg">
                                </a>
                            </li>
                            <li>
                                <a href="#">
                                    <img src="images/assets/lookbookThumb.jpg">
                                </a>
                            </li>
                            <li>
                                <a href="#">
                                    <img src="images/assets/lookbookThumb2.jpg">
                                </a>
                            </li>
                            <li>
                                <a href="#">
                                    <img src="images/assets/lookbookThumb3.jpg">
                                </a>
                            </li>
                        </ul>
                        <a href="#" class="ess-icon banner-prev"></a>
                        <a href="#" class="ess-icon banner-next"></a>
                    </div>
                </div><!-- end 你可能喜歡 -->

                <!-- 瀏覽紀錄 -->
                <div class="pdcnt_relatedlist clearfix">
                    <img src="images/titles/viewhistory.png" class="sectionTitle">
                    <div class="secSlide">
                        <ul>
                            <li>
                                <a href="#">
                                    <img src="images/assets/lookbookThumb.jpg">
                                </a>
                            </li>
                            <!-- <li>
                                <a href="#">
                                    <img src="images/assets/lookbookThumb2.jpg">
                                </a>
                            </li>
                            <li>
                                <a href="#">
                                    <img src="images/assets/lookbookThumb3.jpg">
                                </a>
                            </li>
                            <li>
                                <a href="#">
                                    <img src="images/assets/lookbookThumb.jpg">
                                </a>
                            </li>
                            <li>
                                <a href="#">
                                    <img src="images/assets/lookbookThumb2.jpg">
                                </a>
                            </li>
                            <li>
                                <a href="#">
                                    <img src="images/assets/lookbookThumb3.jpg">
                                </a>
                            </li> -->
                        </ul>
                        <a href="#" class="ess-icon banner-prev"></a>
                        <a href="#" class="ess-icon banner-next"></a>
                    </div>
                </div><!-- end 瀏覽紀錄 -->

                <input type="hidden" name="" :value="currentColor.value" id="value_color">
                
                <input type="hidden" name="" :value="allData[currentIdx]['size'][currentSizeIdx]['value']" id="value_size">

                <input type="hidden" name="" :value="currentNumber" id="value_number">

            </div>
            @@include('./template/_pageFooter.html')

    	</div><!-- end pageWrap -->

        <script>
            
            // var colorCode = '02';
            // var data = [
            //     {
            //         "color": {"name": "白", "value": "01", "img": "images/assets/pdcolor1.jpg"},
            //         "size": [
            //             {"name": "S", "value": "s", "qty": 0},
            //             {"name": "M", "value": "m", "qty": 8},
            //             {"name": "L", "value": "l", "qty": 13}
            //         ],
            //         "imgs": [
            //             "images/assets/pd1-1.jpg",
            //             "images/assets/pd1-2.jpg",
            //             "images/assets/pd1-32.jpg"
            //         ]
            //     },
            //     {
            //         "color": {"name": "天空藍", "value": "02", "img": "images/assets/pdcolor2.jpg"},
            //         "size": [
            //             {"name": "S", "value": "s", "qty": 10},
            //             // {"name": "M", "value": "m", "qty": 8},
            //             {"name": "L", "value": "l", "qty": 13}
            //         ],
            //         "imgs": [
            //             "images/assets/pd2-1.jpg",
            //             "images/assets/pd2-2.jpg",
            //             "images/assets/pd2-3.jpg"
            //         ]
            //     }
            // ];

            // var colorCode = $('#ContentPlaceHolder1_hidColor').val();
            var colorCode = '137';
            var data = [
                {
                    "color":{
                        "name":"深藍",
                        "value":"130",
                        "img":"https://photo.essence.com.tw/Photo/ColorIcon/130.jpg"
                    },
                    "size":[
                        {
                            "name":"S",
                            "value":"S",
                            "qty":"30"
                        },
                        {
                            "name":"M",
                            "value":"M",
                            "qty":"31"
                        },{
                            "name":"L",
                            "value":"L",
                            "qty":"6"
                        }
                    ],
                    "imgs":[
                        "https://photo.essence.com.tw/Photo/06010005/06010005-130-01.jpg",
                        "https://photo.essence.com.tw/Photo/06010005/06010005-130-02.jpg",
                        "https://photo.essence.com.tw/Photo/06010005/06010005-130-03.jpg"
                    ]
                },{
                    "color":{"name":"黑色","value":"137","img":"https://photo.essence.com.tw/Photo/ColorIcon/137.jpg"},"size":[{"name":"S","value":"S","qty":"18"},{"name":"M","value":"M","qty":"44"},{"name":"L","value":"L","qty":"3"}],"imgs":["https://photo.essence.com.tw/Photo/06010005/06010005-137-01.jpg","https://photo.essence.com.tw/Photo/06010005/06010005-137-02.jpg","https://photo.essence.com.tw/Photo/06010005/06010005-137-03.jpg"]}];

            $(function() {

                var vm = new Vue({
                    el: '#pdcnt',
                    data: {
                        sliderImg: [],
                        allData: data,
                        currentIdx: 0,
                        currentColor: {},
                        currentSizeIdx: 0,
                        currentNumber: 1,
                        nostock: false,
                        loadedAll: false
                    },
                    created: function() {
                        var self = this;

                        if (!(colorCode === undefined) && !(colorCode === '')) {
                            self.allData.forEach(function(element, index) {
                                if (element.color.value === colorCode) {
                                    self.currentIdx = index;
                                    self.currentColor = element.color;
                                }
                            });
                        } else {
                            self.currentColor = self.allData[self.currentIdx].color;
                        }

                        self.currentSize = self.allData[self.currentIdx].size[0];

                        self.loadImg(self.allData, 0 , 0);
                        
                    },
                    mounted: function() {
                        var self = this;
                        // var minNumber = (self.allData[self.currentIdx]['size'][self.currentSizeIdx].qty > 0)? 1:0;
                        $('.js-number').TouchSpin({
                            min: 1,
                            max: self.allData[self.currentIdx]['size'][self.currentSizeIdx].qty,
                            buttondown_class: 'numberDown',
                            buttonup_class: 'numberUp'
                        });    
                        this.handleNumber();
                        $('.js-number').on('change', function() {
                            self.currentNumber = $(this).val();
                        });

                        var pdcntTab = tabs({
                            el: '#pdcnt_tab',
                            tabNavigationLinks: '.c-tabs-nav__link',
                            tabContentContainers: '.c-tab'
                        });
                        pdcntTab.init();

                    },
                    updated: function() {
                        this.$nextTick(function () {
                            console.log('updated');
                            if (this.loadedAll) {
                                console.log('updated nextTick and loaded all ' + $('.pdcnt_sliderWrap').eq(1).find('img').length);    
                                this.activeSlide();
                            }
                        })
                    },
                    methods: {
                        loadImg(originData, currentColorIdx, currentImgIdx) {
                            var self = this;
                            var img = new Image();

                            img.onload = function() {
                                currentImgIdx ++;
                                if (currentImgIdx < originData[currentColorIdx].imgs.length) {
                                    self.loadImg(originData, currentColorIdx, currentImgIdx);
                                } else {
                                    currentImgIdx = 0;
                                    currentColorIdx = currentColorIdx + 1;
                                    if (currentColorIdx < originData.length) {
                                        self.loadImg(originData, currentColorIdx, currentImgIdx);  
                                    } else {
                                        self.loadedAll = true;
                                        console.log('loaded all ' + self.loadedAll);
                                        vm.$forceUpdate();
                                    }
                                    
                                }
                                
                            }
                            img.onerror = function() {

                                //刪除
                                self.allData[currentColorIdx].imgs.splice(currentImgIdx, 1);

                                // currentImgIdx ++;

                                if (currentImgIdx < originData[currentColorIdx].imgs.length) {
                                    self.loadImg(originData, currentColorIdx, currentImgIdx);
                                    currentImgIdx ++;
                                } else {
                                    currentImgIdx = 0;
                                    currentColorIdx = currentColorIdx + 1;
                                    if (currentColorIdx < originData.length) {
                                        self.loadImg(originData, currentColorIdx, currentImgIdx);
                                    } else {
                                        self.loadedAll = true;
                                        // console.log('loaded all ' + $('.pdcnt_sliderWrap').eq(1).find('img').length);
                                        console.log('loaded all ' + self.loadedAll);
                                        vm.$forceUpdate();
                                    }
                                }
                            }
                            img.src = originData[currentColorIdx].imgs[currentImgIdx];
                        }, //end loadImg
                        handleNumber() {
                            var self = this;
                            if (this.allData[this.currentIdx]['size'][this.currentSizeIdx].qty > 0) {
                                // console.log('>0');
                                this.nostock = false;
                                $('.js-number').trigger("touchspin.updatesettings", {max: self.allData[self.currentIdx]['size'][self.currentSizeIdx].qty});

                            } else {
                                // console.log('0 ' + $('.js-number').length);
                                this.nostock = true;
                                this.currentNumber = 0;
                                $('.js-number').trigger("touchspin.updatesettings", {max: 0, min: 0});
                            }

                        }, //end handleNumber

                        changeColor(e) {
                            e.preventDefault();
                            this.currentIdx = parseInt($(e.target).parent().data('idx'));
                            this.currentSizeIdx = 0;
                            // this.currentNumber = 1;
                            this.currentColor = this.allData[this.currentIdx].color;
                            this.handleNumber();
                        },

                        changeSize(e) {
                            e.preventDefault();
                            this.currentSizeIdx = parseInt($(e.target).data('idx'));
                            // this.currentNumber = 1;
                            this.handleNumber();
                        },

                        activeSlide() {
                            console.log('slick ' + $('.pdcnt_slide').length);
                            if (!$('.pdcnt_slide').eq(this.currentIdx).hasClass('slick-slider')) {
                                
                                $('.pdcnt_slide').eq(this.currentIdx).slick({
                                    dots: true
                                });
                            }
                        }
                    },
                    watch: {
                        allData: function() {
                        },
                        currentIdx: function() {
                            // console.log('currentIdx change');
                            // this.activeSlide();
                        },
                        loadedAll: function() {
                            // console.log('loadedAll change ' + $('.pdcnt_sliderWrap').eq(1).find('img').length);
                            // var self = this;
                            // self.activeSlide();                                
                        }
                    }
                });

    
                $('.secSlide ul').each(function() {
                    $(this).slick({
                        arrow: true,
                        slidesToShow: 3,
                        slidesToScroll: 1,
                        prevArrow: $(this).siblings('.banner-prev'),
                        nextArrow: $(this).siblings('.banner-next')
                    });
                });
            });

        </script>

        <!-- <script data-main="scripts/app" src="scripts/require.js"></script> -->
        

    	<div class="pageCover"></div>
    	@@include('./template/_footer.html')
    	
    </body>
</html>